diff --git a/tests/t3lib/file/t3lib_file_repositoryTest.php b/tests/t3lib/file/t3lib_file_repositoryTest.php
new file mode 100644
index 0000000..ce82a1a
--- /dev/null
+++ tests/t3lib/file/t3lib_file_repositoryTest.php
@@ -0,0 +1,195 @@
+<?php
+
+class t3lib_file_repositoryTest extends tx_phpunit_testcase {
+
+	protected function _getFakedMount($uid, $alias) {
+		return new t3lib_file_Mount(array('uid' => $uid, 'alias' => $alias));
+	}
+
+	/**
+	 * @test
+	 */
+	public function getByIdFetchesCorrectRecordFromDatabase() {
+		$fakeRecord = array(
+			'uid' => 1,
+			'file_name' => 'test.jpg',
+			'file_path' => 'just/a/testfolder/somewhere/',
+			'file_size' => 1234,
+			'mount' => 0
+		);
+		$databaseMock = $this->getMock('t3lib_DB', array('exec_SELECTgetRows'));
+		$databaseMock->expects($this->at(0))->method('exec_SELECTgetRows')->with(
+			$this->anything(),
+			$this->equalTo('sys_files'),
+			$this->stringEndsWith($fakeRecord['uid'])
+		)->will($this->returnValue(array($fakeRecord)));
+
+		$fakedMount = $this->_getFakedMount(0, 'fileadmin');
+
+		$GLOBALS['TYPO3_DB'] = $databaseMock;
+		$repository = $this->getMock('t3lib_file_Repository', array('getMountForFile'));
+		$repository->expects($this->any())->method('getMountForFile')->will($this->returnValue($fakedMount));
+
+		$fileObject = $repository->getFileById($fakeRecord['uid']);
+		$this->assertType('t3lib_file_File', $fileObject);
+		$this->assertEquals($fakeRecord['uid'], $fileObject->getUid());
+	}
+
+	/**
+	 * @test
+	 */
+	public function getByIdThrowsExceptionIfRecordDoesNotExist() {
+		$databaseMock = $this->getMock('t3lib_DB', array('exec_SELECTgetRows'));
+		$databaseMock->expects($this->once())->method('exec_SELECTgetRows')->with(
+				$this->anything(),
+				$this->equalTo('sys_files'),
+				$this->anything()
+			)->will($this->returnValue(array()));
+
+		$fakedMount = $this->_getFakedMount(0, 'fileadmin');
+
+		$GLOBALS['TYPO3_DB'] = $databaseMock;
+		$repository = $this->getMock('t3lib_file_Repository', array('getMountForFile'));
+		$repository->expects($this->any())->method('getMountForFile')->will($this->returnValue($fakedMount));
+
+		$this->setExpectedException('t3lib_file_exception_FileNotFound');
+		$repository->getFileById(1);
+	}
+
+	/**
+	 * @test
+	 */
+	public function getFileByPathFetchesCorrectRecordFromDatabase() {
+		$fakeRecord = array(
+			'uid' => 1,
+			'file_name' => 'test.jpg',
+			'file_path' => 'fileadmin/just/a/testfolder/somewhere/',
+			'file_size' => 1234,
+			'mount' => 0
+		);
+		$databaseMock = $this->getMock('t3lib_DB', array('exec_SELECTgetRows'));
+		$databaseMock->expects($this->once())->method('exec_SELECTgetRows')->with(
+			$this->anything(),
+			$this->equalTo('sys_files'),
+			$this->logicalAnd($this->stringContains('"' . $fakeRecord['file_name'] . '"'), $this->stringContains('"' . $fakeRecord['file_path'] . '"'))
+		)->will($this->returnValue(array($fakeRecord)));
+
+		$fakedMount = $this->_getFakedMount(0, 'fileadmin');
+
+		$GLOBALS['TYPO3_DB'] = $databaseMock;
+		$repository = $this->getMock('t3lib_file_Repository', array('getMountForFile'));
+		$repository->expects($this->any())->method('getMountForFile')->will($this->returnValue($fakedMount));
+
+		$fileObject = $repository->getFileByPath($fakeRecord['file_path'] . $fakeRecord['file_name']);
+		$this->assertType('t3lib_file_File', $fileObject);
+	}
+
+	/**
+	 * @test
+	 */
+	public function getAllInPathFetchesAllRecordsFromPath() {
+		$fakePath = 'just/a/testfolder/somewhere/';
+		$fakeRecords = array(
+			array(
+				'uid' => 1,
+				'file_name' => 'test.jpg',
+				'file_path' => $fakePath,
+				'file_size' => 1234,
+				'mount' => 0
+			),
+			array(
+				'uid' => 2,
+				'file_name' => 'test.odt',
+				'file_path' => $fakePath,
+				'file_size' => 321,
+				'mount' => 0
+			)
+		);
+		$databaseMock = $this->getMock('t3lib_DB', array('exec_SELECTgetRows'));
+		$databaseMock->expects($this->once())->method('exec_SELECTgetRows')->with(
+			$this->anything(),
+			$this->equalTo('sys_files'),
+			$this->stringContains('"' . $fakePath . '"')
+		)->will($this->returnValue($fakeRecords));
+
+		$GLOBALS['TYPO3_DB'] = $databaseMock;
+		// TODO: use the real mount here
+		$mount = t3lib_file_Mount::getInstanceForUid(0);
+
+		$repository = new t3lib_file_Repository();
+
+		$fileObjects = $repository->getAllInPath($fakePath);
+		$this->assertType('array', $fileObjects);
+		$this->assertEquals(2, count($fileObjects));
+		$this->assertType('t3lib_file_File', $fileObjects[0]);
+		$this->assertType('t3lib_file_File', $fileObjects[1]);
+		$this->assertEquals($fileObjects[0], new t3lib_file_File($mount, $fakeRecords[0]));
+		$this->assertEquals($fileObjects[1], new t3lib_file_File($mount, $fakeRecords[1]));
+	}
+
+	/**
+	 * @test
+	 */
+	public function getFilesFromRelation() {
+		t3lib_div::loadTCA('tx_test');
+		$fakePath = 'just/a/testfolder/somewhere/';
+		$fakeRecords = array(
+			array(
+				'uid' => 1,
+				'file_name' => 'test.jpg',
+				'file_path' => $fakePath,
+				'file_size' => 1234,
+				'mount' => 0
+			),
+			array(
+				'uid' => 2,
+				'file_name' => 'test.odt',
+				'file_path' => $fakePath,
+				'file_size' => 321,
+				'mount' => 0
+			)
+		);
+		$fakeRelations = array(
+			array(
+				'tablenames' => 'sys_files_usage_mm',
+				'uid_foreign' => '8',
+				'uid_local' => '1',
+				'table' => 'tx_test',
+				'ident' => 'testField'
+			)
+		);
+
+		$GLOBALS['TCA']['tx_test']['columns']['testField']['config'] = array(
+			'type' => 'group',
+			'internal_type' => 'db',
+			'allowed' => 'sys_files',
+			'internal_subtype' => 'file_record',
+			'internal_subtype_allowed' => 'gif,jpg,jpeg,tif,tiff,bmp,pcx,tga,png,pdf,ai',
+			'prepend_tname' => 1,
+			'size' => 5,
+			'minitems' => 0,
+			'MM_opposite_field' => 'file_usage',
+			'MM' => 'sys_files_usage_mm',
+			'MM_match_fields' => array(
+				'ident' => 'testField'
+			)
+		);
+
+		$databaseMock = $this->getMock('t3lib_DB', array('exec_SELECTgetRows'));
+		$databaseMock->expects($this->once())->method('exec_SELECTgetRows')->will($this->returnValue(array($fakeRecords[0])));
+		$databaseMock->expects($this->once())->method('exec_SELECTgetRows')->with(
+			$this->anything(),
+			$this->equalTo('sys_files_usage_mm')
+		)->will($this->returnValue($fakeRelations));
+
+		$GLOBALS['TYPO3_DB'] = $databaseMock;
+
+		$repository = new t3lib_file_Repository();
+
+		$fileObjects = $repository->getFilesFromRelation('testField', 'tx_test', 1);
+		$this->assertType('array', $fileObjects);
+		$this->assertEquals(1, count($fileObjects));
+	}
+}
+
+?>
\ No newline at end of file
diff --git a/typo3/backend.php b/typo3/backend.php
index 29acdad..91173ea 100644
--- typo3/backend.php
+++ typo3/backend.php
@@ -128,7 +128,11 @@ class TYPO3backend {
 			'toolbarmanager'        => 'js/toolbarmanager.js',
 			'modulemenu'            => 'js/modulemenu.js',
 			'iecompatibility'       => 'js/iecompatibility.js',
-			'flashupload'           => 'js/flashupload.js',
+			'plupload_gears'        => 'contrib/plupload/js/gears_init.js',
+			'plupload_browserplus'  => 'contrib/yahooapis/browserplus-min.js',
+			'plupload_full'         => 'contrib/plupload/js/plupload.full.min.js',
+			'plupload_extjs'        => '../t3lib/js/extjs/ux/ext.ux.plupload.js',
+		    'plupload'              => 'js/plupload.js',
 			'evalfield'             => '../t3lib/jsfunc.evalfield.js',
 			'flashmessages'         => '../t3lib/js/extjs/ux/flashmessages.js',
 			'tabclosemenu'          => '../t3lib/js/extjs/ux/ext.ux.tabclosemenu.js',
@@ -628,8 +632,13 @@ class TYPO3backend {
 	public function addJavascriptFile($javascriptFile) {
 		$jsFileAdded = false;
 
+		$checkFile = $javascriptFile;
+		$queryStarts = strpos($checkFile,'?');
+		if ($queryStarts !== false){
+			$checkFile = substr($checkFile,0,$queryStarts);
+		} 
 			//TODO add more checks if neccessary
-		if(file_exists(t3lib_div::resolveBackPath(PATH_typo3.$javascriptFile))) {
+		if(file_exists(t3lib_div::resolveBackPath(PATH_typo3.$checkFile))) {
 			$this->jsFiles[] = $javascriptFile;
 			$jsFileAdded     = true;
 		}
diff --git a/typo3/class.browse_links.php b/typo3/class.browse_links.php
index d32d66d..50da974 100644
--- typo3/class.browse_links.php
+++ typo3/class.browse_links.php
@@ -653,6 +653,7 @@ class browse_links {
 	var $setTitle;      		// title (RTE specific)
 	var $doc;			// Backend template object
 	var $elements = array();	// Holds information about files
+	protected $isFileAbstractionLayerMode = false; // Determines if the element browser is in the File Abstraction Layer (FAL) mode. This means it will return sys_file UIDs instead of paths to files even when it's running in the "file" mode.
 
 		// GPvars:	(Input variables from outside)
 	/**
@@ -704,6 +705,7 @@ class browse_links {
 	 * 5: IRRE uniqueness: name of function in opener window that checks if element is already used, eg. "inline.checkUniqueElement"
 	 * 6: IRRE uniqueness: name of function in opener window that performs some additional(!) action, eg. "inline.setUniqueElement"
 	 * 7: IRRE uniqueness: name of function in opener window that performs action instead of using addElement/insertElement, eg. "inline.importElement"
+	 * 8: FAL mode: Determines if the file browser is used in the File Abstraction Layer (FAL) mode (zero or one)
 	 *
 	 * $pArr = explode('|',$this->bparams);
 	 * $formFieldName = $pArr[0];
@@ -778,12 +780,26 @@ class browse_links {
 		if (!$this->mode)	{
 			$this->mode = 'rte';
 		}
+		
+		/**
+		 * Splits parts of $this->bparams
+		 * @see $bparams
+		 */
+		$pArr = explode('|',$this->bparams);
+		$this->isFileAbstractionLayerMode = (bool)$pArr[8];
+
 			// Creating backend template object:
 		$this->doc = t3lib_div::makeInstance('template');
 		$this->doc->backPath = $GLOBALS['BACK_PATH'];
 			// Load the Prototype library and browse_links.js
 		$this->doc->getPageRenderer()->loadPrototype();
 		$this->doc->loadJavascriptLib('js/browse_links.js');
+		
+		if($this->isFileAbstractionLayerMode) {
+			$this->doc->getPageRenderer()->loadExtJS();
+			$this->doc->getPageRenderer()->addJSFile($this->doc->backPath.'ajax.php?ajaxID=ExtDirect::getAPI&namespace=TYPO3.FAL', NULL, false);
+			$this->doc->getPageRenderer()->addExtDirectCode();
+		}
 
 			// init hook objects:
 		$this->hookObjects = array();
@@ -1047,12 +1063,6 @@ class browse_links {
 		';
 
 
-		/**
-		 * Splits parts of $this->bparams
-		 * @see $bparams
-		 */
-		$pArr = explode('|',$this->bparams);
-
 			// This is JavaScript especially for the TBE Element Browser!
 		$formFieldName = 'data['.$pArr[0].']['.$pArr[1].']['.$pArr[2].']';
 
@@ -1084,10 +1094,11 @@ class browse_links {
 					}
 			';
 		}
+		$JScodeAction = '';
 			// insertElement - perform action commands:
 		if ($pArr[4] && $pArr[7]) {
 				// Call user defined action function:
-			$JScodeAction = '
+			$JScodeAction .= '
 					if (parent.window.opener) {
 						parent.window.opener.'.$pArr[7].'("'.addslashes($pArr[4]).'",table,uid,type);
 						focusOpenerAndClose(close);
@@ -1097,11 +1108,21 @@ class browse_links {
 					}
 			';
 		} else if ($pArr[0] && !$pArr[1] && !$pArr[2]) {
-			$JScodeAction = '
-					addElement(filename,table+"_"+uid,fp,close);
-			';
+			
+			if($this->isFileAbstractionLayerMode) {
+				$JScodeAction .= '
+					TYPO3.FAL.ExtDirect.test(fp, function(response) {
+						addElement(filename,table+"_"+uid,response,close);
+					});
+				';
+			} else {
+				$JScodeAction .= '
+						addElement(filename,table+"_"+uid,fp,close);
+				';
+			}
+
 		} else {
-			$JScodeAction = '
+			$JScodeAction .= '
 					if (setReferences()) {
 						parent.window.opener.group_change("add","'.$pArr[0].'","'.$pArr[1].'","'.$pArr[2].'",elRef,targetDoc);
 					} else {
@@ -1153,7 +1174,8 @@ class browse_links {
 				BrowseLinks.focusOpenerAndClose(close);
 			}
 		';
-
+		
+		
 			// Finally, add the accumulated JavaScript to the template object:
 		$this->doc->JScode.= $this->doc->wrapScriptTags($JScode);
 
@@ -1170,9 +1192,16 @@ class browse_links {
 			'expandPage' => $this->expandPage,
 			'expandFolder' => $this->expandFolder,
 			'PM' => $this->PM,
+			'isFileAbstractionLayerMode' => $this->isFileAbstractionLayerMode,
 		),'Internal variables of Script Class:');
 	}
-
+	
+	
+	function initExtDirect() {
+		
+	}
+	
+	
 
 	/**
 	 * Session data for this class can be set from outside with this method.
diff --git a/typo3/classes/class.typo3_tcefile.php b/typo3/classes/class.typo3_tcefile.php
index 39cdaab..f31988e 100644
--- typo3/classes/class.typo3_tcefile.php
+++ typo3/classes/class.typo3_tcefile.php
@@ -164,16 +164,64 @@ class TYPO3_tcefile {
 	 */
 	public function processAjaxRequest(array $params, TYPO3AJAX $ajaxObj) {
 		$this->init();
+		$this->checkRawRequest($params, $ajaxObj);
 		$this->main();
-		$errors = $this->fileProcessor->getErrorMessages();
-		if (count($errors)) {
-			$ajaxObj->setError(implode(',', $errors));
+		
+		$response = array();
+		$error = null;
+		foreach ($this->fileData['upload'] as $uploaded) {
+			// $uploaded would contain the absolute file path, if it worked
+			if ($uploaded === null) {
+				$error = $this->fileProcessor->lastError;
+				break;
+			}
+		}
+		if (strlen($error)) {
+			$response['message'] = $error;
+			$response['success'] = FALSE;
 		} else {
-			$ajaxObj->addContent('result', $this->fileData);
+			$response['result'] = $this->fileData;
 			if ($this->redirect) {
-				$ajaxObj->addContent('redirect', $this->redirect);
+				$response['redirect'] = $this->redirect;
 			}
-			$ajaxObj->setContentFormat('json');
+			$response['success'] = TRUE;
+		}
+		$ajaxObj->setContentFormat('plain');
+		$ajaxObj->setContent(array(json_encode($response)));
+	}
+	
+	protected function checkRawRequest(array $params, TYPO3AJAX $ajaxObj) {
+
+		// Look for the content type header
+		if (isset($_SERVER["HTTP_CONTENT_TYPE"]))
+			$contentType = $_SERVER["HTTP_CONTENT_TYPE"];
+
+		if (isset($_SERVER["CONTENT_TYPE"]))
+			$contentType = $_SERVER["CONTENT_TYPE"];
+
+		if (strpos($contentType, "multipart") === false) {
+			$tempFile = tempnam('/tmp', 'upload');
+
+			// Open temp file
+			$out = fopen($tempFile, 'wb');
+			if ($out) {
+				// Read binary input stream and append it to temp file
+				$in = fopen("php://input", "rb");
+
+				if ($in) {
+					while ($buff = fread($in, 4096))
+						fwrite($out, $buff);
+				} else
+					die('{"jsonrpc" : "2.0", "error" : {"code": 101, "message": "Failed to open input stream."}, "id" : "id"}');
+				fclose($out);
+				$_FILES['upload_1'] = array(
+					'name' => $_GET['file']['upload']['1']['name'],
+					'tmp_name' => $tempFile,
+					'size' => filesize($tempFile),
+					'target' => $_GET['file']['upload']['1']['target'],
+				);
+			} else
+				die('{"jsonrpc" : "2.0", "error" : {"code": 102, "message": "Failed to open output stream."}, "id" : "id"}');
 		}
 	}
 }
diff --git a/typo3/js/browse_links.js b/typo3/js/browse_links.js
index f39aa86..d426c71 100755
--- typo3/js/browse_links.js
+++ typo3/js/browse_links.js
@@ -43,10 +43,12 @@ var BrowseLinks = {
 };
 
 BrowseLinks.File = {
-	insertElement: function(index, close) {
+	insertElement: function(index, close, mode) {
+	
 		var result = false;
 		if (typeof BrowseLinks.elements[index] !== undefined) {
 			var element = BrowseLinks.elements[index];
+						
 			result = insertElement(
 				'', element.md5, element.type,
 				element.fileName, element.filePath, element.fileExt,
diff --git a/typo3/js/common.js b/typo3/js/common.js
index 863e388..f8e6f29 100644
--- typo3/js/common.js
+++ typo3/js/common.js
@@ -77,7 +77,9 @@ T3AJAX.showError = function(xhr, json) {
 };
 
 // common storage and global object, could later hold more information about the current user etc.
-var TYPO3 = {
+if (!TYPO3) TYPO3 = {}
+
+TYPO3 = Ext.extend(TYPO3, {
 	// store instances that only should be running once
 	_instances: {},
 	getInstance: function(className) {
@@ -99,4 +101,4 @@ var TYPO3 = {
 			return res;
 		}
 	}
-};
+});
diff --git a/typo3/js/plupload.js b/typo3/js/plupload.js
new file mode 100644
index 0000000..7bbec2e
--- /dev/null
+++ typo3/js/plupload.js
@@ -0,0 +1,186 @@
+Ext.ns('TYPO3.Components','TYPO3.Components.filelist');
+
+Ext.onReady(function() {
+	var plp = new Ext.ux.PluploadPanel({
+	    region: 'center',
+	    split: true,
+	    width: 500,
+	    height: 350,
+	    url: TYPO3.configuration.PATH_typo3 + 'ajax.php',
+	    runtimes: 'html5,flash,silverlight,browserplus,gears,html4',
+	    multipart: false,
+	    multipart_params: { },
+	    file_data_name: 'upload_1',
+	
+	    max_file_size: '100mb',
+	
+	    /* image resizing */
+	    /*resize: {width : 640, height : 480, quality : 60},*/
+	
+	    flash_swf_url : '/typo3/contrib/plupload/js/plupload.flash.swf',
+	    silverlight_xap_url : '/typo3/contrib/plupload/js/plupload.silverlight.xap',
+	
+	    /*filters: [  {title : "Image files", extensions : "jpg,JPG,gif,GIF,png,PNG"},
+	                {title : "Zip files", extensions : "zip,ZIP"},
+	                {title : "Text files", extensions : "txt,TXT"}
+	             ],*/
+	
+	    runtime_visible: true,
+	
+	    addButtonCls: 'silk-add',
+	    uploadButtonCls: 'silk-arrow-up',
+	    cancelButtonCls: 'silk-stop',
+	    deleteButtonCls: 'silk-cross',
+	
+	    addButtonText: 'Add files',
+	    uploadButtonText: 'Upload',
+	    cancelButtonText: 'Cancel upload',
+	    deleteButtonText: 'Remove',
+	    deleteSelectedText: '<b>Remove selected</b>',
+	    deleteUploadedText: 'Remove uploaded',
+	    deleteAllText: 'Remove ALL',
+	
+	    statusQueuedText: 'Queued',
+	    statusUploadingText: 'Uploading ({0}%)',
+	    statusFailedText: '<span style="color: red">FAILED</span>',
+	    statusDoneText: '<span style="color: green">DONE</span>',
+	
+	    statusInvalidSizeText: 'Too big',
+	    statusInvalidExtensionText: 'Invalid file type',
+	
+	    emptyText: '<div class="plupload_emptytext"><span>Upload queue is empty</span></div>',
+	    emptyDropText: '<div class="plupload_emptytext"><span>Drop files here</span></div>',
+	
+	    progressText: '{0}/{1} ({3} failed) ({5}/s)',
+	
+	    listeners: {
+	        beforestart: function(uploadpanel) {
+	            // As TYPO3_tcefile::process expects this parameter dependent on the file (because of the parameter name)
+	            // we have to update the upload url for every single file (and not in "beforestart" as in the original file
+	            var parameters = {
+	                "file": "upload_1",
+	                "file[upload][1][name]": uploadpanel.uploader.files[0].name,
+	                "file[upload][1][target]": top.TYPO3.configuration.FileUpload.targetDirectory,
+	                "file[upload][1][data]": 1,
+	                "file[upload][1][charset]": "utf-8",
+	                "ajaxID": "TYPO3_tcefile::process",
+	                "vC": top.TYPO3.configuration.veriCode
+	            };
+	    
+	            uploadpanel.uploader.settings.url = this.url + '?' + Ext.urlEncode(parameters);
+	        },
+	        uploadfile: function(uploadpanel, uploader, file) {
+	
+	            // As TYPO3_tcefile::process expects this parameter dependent on the file (because of the parameter name)
+	            // we have to update the upload url for every single file (and not in "beforestart" as in the original file
+	            var parameters = {
+	                "file": "upload_1",
+	                "file[upload][1][name]": file.name,
+	                "file[upload][1][target]": top.TYPO3.configuration.FileUpload.targetDirectory,
+	                "file[upload][1][data]": 1,
+	                "file[upload][1][charset]": "utf-8",
+	                "ajaxID": "TYPO3_tcefile::process",
+	                "vC": top.TYPO3.configuration.veriCode
+	            };
+	            uploader.settings.url = this.url + '?' + Ext.urlEncode(parameters);
+	        },
+	        uploadstarted: function(uploadpanel) {
+	
+	        },
+	        uploadcomplete: function(uploadpanel, success, failures) {
+/*
+	            if ( success.length && failures.length == 0) {
+	                Ext.Msg.alert('success!', 'all worked');
+	            } else if (success.length) {
+		            Ext.Msg.alert('partly..', 'some worked, some not');
+	            } else {
+		            Ext.Msg.alert('nothing?', 'seems like nothing worked this time');
+	            }
+*/
+	        }
+	    }
+	});
+	
+	var tree = {region:'west', hidden:true};
+	if(TYPO3.Components.filelist.FolderTree){
+		tree = new TYPO3.Components.filelist.FolderTree({
+			id: 't3-upload-window-tree',
+			region: 'west',
+			layout: 'fit',
+			width: 180,
+			minWidth: 20,
+			floatable: true,
+			animCollapse: false,
+			split: true,
+			collapsible: true,
+			collapseMode: 'mini',
+			hideCollapseTool: true,
+			stateful:true,
+			autoScroll: true,
+			border: false,
+			hidden:true,
+			listeners:{
+				click: {
+					fn: function(){
+						
+					}
+				}
+			}
+		});
+	}
+	
+	TYPO3.FileUploadWindow = new Ext.Window({
+	    width: 600,
+	    height: 350,
+		center: true,
+		modal: true,
+		id: 't3-upload-window',
+		layout:'border',
+		title: String.format(TYPO3.LLL.fileUpload.windowTitle),
+		shadow: false,
+		hideBorders: true,
+		closeAction:'hide',
+		maximizable:true,
+		items:[tree,plp],
+		listeners:{
+			hide:{
+				fn: function(){
+					plp.onDeleteAll();
+				}
+			}
+		},
+		bbar:['->',{
+			text:'Upload',
+			disabled:true
+		},{
+			text:'Cancel',
+			handler: function(){
+				TYPO3.FileUploadWindow.hide();
+			}
+		}],
+		showFilelistUploadDialog: function(target){
+			top.TYPO3.configuration.FileUpload = {targetDirectory:target};
+			var tree = Ext.getCmp('t3-upload-window-tree');
+			if (tree) {
+				tree.hide();
+			}
+			TYPO3.FileUploadWindow.show();
+			return false;
+		},
+		showFalTceFormsUploadDialog: function(field,allowed){
+			if(!top.TYPO3.configuration.FileUpload){
+				top.TYPO3.configuration.FileUpload = {targetDirectory:'fileadmin/_temp_/'};
+			}
+			var tree = Ext.getCmp('t3-upload-window-tree');
+			if (tree) {
+				tree.show();
+			}
+			TYPO3.FileUploadWindow.show();
+			return false;
+		}
+	});
+});
+Ext.onReady(function(){
+	Ext.QuickTips.init();
+	Ext.state.Manager.setProvider(new Ext.state.CookieProvider());
+});
